# SYMBIAN_UID = 0x100002B6#
# Musician, created by Steve Litchfield, now open source.
# to do: add tap-tempo function
# add louder/quieter metronome (diff samples)
# setting for different piano note lengths (within reason)??


import appuifw
from graphics import *
import e32
from key_codes import *
from appuifw import *
import os
import audio
import time
import random
import time
import sysinfo

timer = e32.Ao_timer()
app_lock = e32.Ao_lock()

class Keyboard(object):
    def __init__(self,onevent=lambda:None):
        self._keyboard_state={}
        self._downs={}
        self._onevent=onevent
    def handle_event(self,event):
        if event['type'] == appuifw.EEventKeyDown:
            code=event['scancode']
            if not self.is_down(code):
                self._downs[code]=self._downs.get(code,0)+1
            self._keyboard_state[code]=1
        elif event['type'] == appuifw.EEventKeyUp:
            self._keyboard_state[event['scancode']]=0
        self._onevent()
    def is_down(self,scancode):
        return self._keyboard_state.get(scancode,0)
    def pressed(self,scancode):
        if self._downs.get(scancode,0):
            self._downs[scancode]-=1
            return True
        return False
keyboard=Keyboard()

version=u'2.3'
soundflag=1
tuninglength=0
registered=0
dummy1=0 # dummy variable, for later extension to the settings file
dummy2=0

appuifw.app.screen='full'
img=None
def handle_redraw(rect):
    if img:
        canvas.blit(img)
appuifw.app.body=canvas=appuifw.Canvas(
    event_callback=keyboard.handle_event,
    redraw_callback=handle_redraw)

img=Image.new(canvas.size) # (a 2 element tuple)
[width,height]=img.size

def cache_files():
# put all sound files in RAM drive for better performance, if not already there

    if os.path.exists("D:\\ptopc.mid"):
        dummy1=0
    else:
        e32.file_copy("D:\\metronome.wav","E:\\musician\\metronome.wav")
        e32.file_copy("D:\\metronome.wav","E:\\musician\\metronome.wav")
        e32.file_copy("D:\\a.mid","E:\\musician\\a.mid")
        e32.file_copy("D:\\b.mid","E:\\musician\\b.mid")
        e32.file_copy("D:\\d.mid","E:\\musician\\d.mid")
        e32.file_copy("D:\\e.mid","E:\\musician\\e.mid")
        e32.file_copy("D:\\g.mid","E:\\musician\\g.mid")
        e32.file_copy("D:\\pc.mid","E:\\musician\\pc.mid")
        e32.file_copy("D:\\pcsharp.mid","E:\\musician\\pcsharp.mid")
        e32.file_copy("D:\\pd.mid","E:\\musician\\pd.mid")
        e32.file_copy("D:\\pdsharp.mid","E:\\musician\\pdsharp.mid")
        e32.file_copy("D:\\pe.mid","E:\\musician\\pe.mid")
        e32.file_copy("D:\\pf.mid","E:\\musician\\pf.mid")
        e32.file_copy("D:\\pfsharp.mid","E:\\musician\\pfsharp.mid")
        e32.file_copy("D:\\pg.mid","E:\\musician\\pg.mid")
        e32.file_copy("D:\\pgsharp.mid","E:\\musician\\pgsharp.mid")
        e32.file_copy("D:\\pa.mid","E:\\musician\\pa.mid")
        e32.file_copy("D:\\pbflat.mid","E:\\musician\\pbflat.mid")
        e32.file_copy("D:\\pb.mid","E:\\musician\\pb.mid")
        e32.file_copy("D:\\ptopc.mid","E:\\musician\\ptopc.mid")


def piano():

    if width > height:
        img.load("E:\\musician\\keyboard320.raw",callback=handle_redraw)
    else:
        img.load("E:\\musician\\keyboard240.raw",callback=handle_redraw)

    handle_redraw(())

    delay=0.02 # delay means that loop doesn't burn round so fast that nothing works
    timer.after(delay)
    S = 0
    
    while 1:
        if keyboard.pressed(EScancodeStar):
            S = audio.Sound.open("D:\\pc.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode7):
            S = audio.Sound.open("D:\\pcsharp.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode4):
            S = audio.Sound.open("D:\\pd.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode1):
            S = audio.Sound.open("D:\\pdsharp.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode0):
            S = audio.Sound.open("D:\\pe.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode8):
            S = audio.Sound.open("D:\\pf.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode5):
            S = audio.Sound.open("D:\\pfsharp.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode2):
            S = audio.Sound.open("D:\\pg.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancodeHash):
            S = audio.Sound.open("D:\\pgsharp.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode9):
            S = audio.Sound.open("D:\\pa.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode6):
            S = audio.Sound.open("D:\\pbflat.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancode3):
            S = audio.Sound.open("D:\\pb.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancodeBackspace):
            S = audio.Sound.open("D:\\ptopc.mid")
            S.play(1,0)
        elif keyboard.pressed(EScancodeLeftSoftkey):  #want to exit piano
            if S != 0:
                S.stop()
                
            break
            
        e32.ao_yield()
        timer.after(delay)
    
    menu()

def calcdelay(tempo):
    return float(60)/float(tempo) # in seconds


def writetempo(tempo):

    # appuifw.note(u'Tempo: '+str(tempo), "info")
    
    img.rectangle((0,height/2.0-25,240,height/2.0),0x0000ff, fill=0x0000ff) #blank previous value
    img.text((20,height/2.0-10), u'Tempo (bpm): '+str(tempo) , font='title') 


def metronome():
    global soundflag
 
    tempo=49
    while (tempo<50 or tempo>220): # got to make sure the number's sensible!
        tempo = appuifw.query(u"Tempo (bpm):", "number")
        if (tempo<50 or tempo>220):
            appuifw.note(u"Tempo out of range (50 to 220)", "error")

    delay=calcdelay(tempo)
        
    if soundflag == 1:
        S = audio.Sound.open("D:\\metronome.wav")
        
    img.clear(0x0000ff)
    handle_redraw(())
    writetempo(tempo)

    appuifw.note(u"You can use left-right or up-down to nudge this tempo...", "info")
    metroheight = height/3.0


    for n in range(1, 9000): # will eventually return to menu, just in case!
    
    
        if soundflag == 1:
            S.play()
            
        img.rectangle((0,0,width,metroheight),0xff0000, fill=0xff0000)
        handle_redraw(())
        if keyboard.pressed(EScancodeLeftSoftkey):  #want to exit metronome
            if soundflag == 1:
                S.stop()
            break
        elif (keyboard.pressed(EScancodeLeftArrow) or keyboard.pressed(EScancodeDownArrow)) :  #reduce tempo
            tempo=tempo-1
            delay=calcdelay(tempo)
            writetempo(tempo)
        elif (keyboard.pressed(EScancodeRightArrow) or keyboard.pressed(EScancodeUpArrow)):  #increase tempo
            tempo=tempo+1
            delay=calcdelay(tempo)
            writetempo(tempo)
             
        timer.after(delay)
        
        if soundflag == 1:
            S.play()
            
        img.rectangle((0,0,width,metroheight),0x0000ff, fill=0x0000ff) 
        img.rectangle((0,height-metroheight-40, width, height-40),0xff0000, fill=0xff0000) 
        handle_redraw(())
        if keyboard.pressed(EScancodeLeftSoftkey):  #want to exit metronome
            if soundflag == 1:
                S.stop()
            break
        elif (keyboard.pressed(EScancodeLeftArrow) or keyboard.pressed(EScancodeDownArrow)) :  #reduce tempo
            tempo=tempo-1
            delay=calcdelay(tempo)
            writetempo(tempo)
        elif (keyboard.pressed(EScancodeRightArrow) or keyboard.pressed(EScancodeUpArrow)):  #increase tempo
            tempo=tempo+1
            delay=calcdelay(tempo)
            writetempo(tempo)

        timer.after(delay)
        
        img.rectangle((0,height-metroheight-40, width, height-40),0x0000ff, fill=0x0000ff)
        handle_redraw(())
        
    menu()




def settings():
    global soundflag
    global tuninglength

    state = [u'Off', u'On']
    svalue = [u'1 bar',u'2 bars', u'3 bars']
    
    data = [(u"Audible metronome",'combo',(state, soundflag)), (u'Tuning length','combo', (svalue, tuninglength))]

    flags = appuifw.FFormEditModeOnly+appuifw.FFormDoubleSpaced
    f = appuifw.Form(data, flags)
    
    # make the form visible on the UI
    f.execute()
    soundflag = int(f[0][2][1])
    tuninglength = int(f[1][2][1])
    
    menu()

def write_settings():
    global registered   
    global soundflag
    global tuninglength
    global dummy1
    global dummy2

    CONFIG_DIR='E:\\musician'
    CONFIG_FILE=os.path.join(CONFIG_DIR,'musician.set')
    if not os.path.isdir(CONFIG_DIR):
        os.makedirs(CONFIG_DIR)
        CONFIG_FILE=os.path.join(CONFIG_DIR,'musician.set')      
    config={}
    config['registered']= registered
    config['sound']= soundflag
    config['tuninglength']= tuninglength
    config['param1']= dummy1
    config['param2']= dummy2
    f=open(CONFIG_FILE,'wt')
    f.write(repr(config))
    f.close()
    

def read_settings():
    global registered   
    global soundflag
    global tuninglength
    global dummy1
    global dummy2
    CONFIG_FILE='E:\\musician\\musician.set'
    try:
        f=open(CONFIG_FILE,'rt')
        try:
            content = f.read()
            config=eval(content)
            f.close()
            registered=config.get('registered','')
            soundflag=config.get('sound','')
            tuninglength=config.get('tuninglength','')
            dummy1=config.get('param1','')
            dummy2=config.get('param2','')
        except:
            appuifw.note(u"Cannot read settings file", "error")
    except:
        appuifw.note(u"Creating settings file", "info")


   
def playtuning(note):
    global pathtoapp
    S = audio.Sound.open("D:\\"+note+".mid")
    S.play((tuninglength+1),0)
    menu()

def exit_key_handler():
    write_settings()
    appuifw.app.set_exit()
    
    
def quit():
    write_settings()
    appuifw.app.set_exit()

L = [u"Piano", u"Metronome", u"Tune to E", u"Tune to B", u"Tune to G", u"Tune to D", u"Tune to A", u"Settings", u"About", u"exit"]

def menu():
    index = appuifw.popup_menu(L)
    if index == 2:
        note='e'
        playtuning(note)
    elif index == 3:
        note='b'
        playtuning(note)
    elif index == 4:
        note='g'
        playtuning(note)
    elif index == 5:
        note='d'
        playtuning(note)
    elif index == 6:
        note='a'
        playtuning(note)
    elif index == 1:
        metronome()
    elif index == 0:
        piano()
    elif index == 7:
        settings()
    elif index == 8:
        about()
    elif index == 9:
        quit()
    else:
        menu()
        
def about():
    appuifw.note(u"Musician v"+version+"\n(C) 2006 Steve Litchfield\nhttp://3lib.ukonline.co.uk/", "info")
    menu()

    
appuifw.app.title = u"Musician"

appuifw.app.exit_key_handler = exit_key_handler
appuifw.app.screen='normal'

read_settings()

cache_files()
menu()
    
    
        
        
    




 

